Package: rfPred
Type: Package
Title: Assign rfPred functional prediction scores to a missense
        variants list
Version: 1.51.0
Date: 2025-07-23
Author: Fabienne Jabot-Hanin, Hugo Varet and Jean-Philippe Jais
Depends: R (>= 3.5.0), methods
Imports: utils, Seqinfo, data.table, IRanges, GenomicRanges, parallel,
        Rsamtools
Suggests: BiocStyle
Maintainer: Hugo Varet <varethugo@gmail.com>
Description: Based on external numerous data files where rfPred scores
        are pre-calculated on all genomic positions of the human exome,
        the package gives rfPred scores to missense variants identified
        by the chromosome, the position (hg19 version), the referent
        and alternative nucleotids and the uniprot identifier of the
        protein. Note that for using the package, the user has to download 
        the TabixFile and index (approximately 3.3 Go).
License: GPL (>=2 )
Encoding: UTF-8
biocViews: Software, Annotation, Classification
RoxygenNote: 7.3.2
git_url: https://git.bioconductor.org/packages/rfPred
git_branch: devel
git_last_commit: 491c390
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
NeedsCompilation: yes
Packaged: 2026-04-29 00:38:41 UTC; biocbuild

#' @exportPattern ^[a-zA-Z]
#' @useDynLib rfPred
#' @import methods
#' @importFrom utils read.table write.csv2
#' @importFrom Seqinfo seqlevels seqlevels<-
#' @importFrom data.table as.data.table
#' @importFrom IRanges reduce IRanges
#' @importFrom GenomicRanges GRanges
#' @importFrom Rsamtools scanTabix TabixFile
#' @importFrom parallel makeCluster stopCluster parLapply clusterSplit
#' @exportMethod rfPred_scores
NULL

#' Motor of \code{rfPred_scores}
#'
#' Motor of \code{rfPred_scores}
#'
#' @param variant_list Variants list in a \code{data.frame} containing 4 or 5 columns:
#' chromosome number, hg19 genomic position on the chromosome, reference nucleotid, variant nucleotid and uniprot protein identifier (optional)
#' @param data Path to the compressed TabixFile, either on the server (default) or on the user's computer
#' @param index Path to the index of the TabixFile, either on the server (default) or on the user's computer
#' @param all.col \code{TRUE} to return all available information, \code{FALSE} to return a more compact result (the most informative columns, see Value)
#' @param file.export Optional, name of the CSV file in which export the results (default is \code{NULL})
#' @param n.cores number of cores to use when scaning the TabixFile, can be efficient for large request (default is 1)
#' @note This function is called by the \code{rfPred_scores} S4 method
#' @return see the \code{\link{rfPred_scores}} function

# last updated: Sept 30, 2022

rfPred_scores_motor=function(variant_list, data, index, all.col, file.export, n.cores){
  # warning message if request on the server
  if (nrow(variant_list)>1000 & data=="http://www.sbim.fr/rfPred/all_chr_rfPred.txtz"){
    stop("For variants lists with more than 1000 rows, please download the TabixFile/index on http://www.sbim.fr/rfPred/ and run rfPred locally")
  }
  
  # formating columns in the right class
  variant_list[, c(1,3:ncol(variant_list))] <- apply(variant_list[, c(1, 3:ncol(variant_list))], 2, as.character)
  variant_list[, 2] <- as.numeric(as.character(variant_list[, 2]))
  names(variant_list) <- c("chromosome", "position_hg19", "reference", "alteration", if(ncol(variant_list)==5){"proteine"}else{NULL})
  variant_list <- as.data.table(variant_list)

  # output columns
  names <- c("chromosome", "position_hg19", "reference", "alteration", "proteine",
             "aaref", "aaalt", "rfPred_score", "SIFT_score", "MutationTaster_score",
             "Polyphen2_score", "PhyloP_score", "LRT_score", "aapos", "Uniprot_id",
             "genename", "position_hg18", "Polyphen2_HDIV_score", "Polyphen2_HDIV_pred", 
             "Polyphen2_HVAR_score", "Polyphen2_HVAR_pred", "MutationTaster_pred", 
             "phyloP", "LRT_Omega", "LRT_pred")
  if (all.col){
    names.out <- names
  } else{
    names.out <- names[1:14]
  }

  # request on TabixFile (chr+pos)
  param <- reduce(GRanges(variant_list$chromosome,
                          IRanges(start=variant_list$position_hg19, width=1)),
                  drop.empty.ranges=TRUE)
  if (n.cores==1){
    res.rst <- scanTabix(TabixFile(data,index),param=param)  
  } else{
    Clust <- makeCluster(n.cores)
    res.rst <- unlist(parLapply(Clust, clusterSplit(Clust, param), 
                                function(variants, file){return(scanTabix(file, param=variants))},
                                TabixFile(data, index)))  
    stopCluster(Clust)
  }
  
  res.rst <- .Call("outstring", unlist(res.rst), as.integer(length(names)), "\t", PACKAGE="rfPred")
  colnames(res.rst) <- names
  res.rst <- as.data.frame(res.rst, stringsAsFactors=FALSE)[, names.out]
  res.rst[, 2] <- as.numeric(res.rst[, 2]) 
  res.rst <- as.data.table(res.rst)
  
  # out for no matching on chr+pos
  out <- merge(unique(variant_list[, 1:2, with=FALSE]), res.rst,
               all.x=TRUE, by=c("chromosome","position_hg19"),
               allow.cartesian=TRUE)
  out[apply(out[, 3:ncol(out), with=FALSE], 1, function(x){all(is.na(x))}), 3:ncol(out)] <- "no matching"
  out <- out[apply(out[, 3:ncol(out), with=FALSE], 1, function(x){all(x=="no matching")}), ]
  variant_list <- merge(variant_list, unique(res.rst[, 1:2, with=FALSE]),
                        by=c("chromosome","position_hg19"),
                        allow.cartesian=TRUE)
   
  # matching on columns 3 and 4 (and possibly 5)
  out <- rbind(out, merge(variant_list, res.rst, all.x=TRUE, by=names(variant_list), allow.cartesian=TRUE))
  if (ncol(variant_list)==5){
    variant_list[,5] <- "."
    out <- rbind(out, merge(variant_list, res.rst, by=names(variant_list), allow.cartesian=TRUE))
  }
  out[apply(out[, (ncol(variant_list)+1):ncol(out), with=FALSE],1,function(x){all(is.na(x))}), (ncol(variant_list)+1):ncol(out)] <- "no matching"

  # sorting the output
  out <- as.data.frame(out[order(factor(out$chromosome, levels=c(1:22, "X", "Y")), as.numeric(out$position_hg19)),])
  rownames(out) <- 1:nrow(out)

  # writing results in a CSV file
  if (!is.null(file.export)){write.csv2(out, file=file.export, row.names=FALSE)}

  return(out)
}

#' Toy example of data.frame
#'
#' @name variant_list_Y
#' @format A data frame with 5 observations on the following 5 variables:
#'   \describe{
#'     \item{\code{chr}}{Chromosome number (only \code{Y} in this example)}
#'     \item{\code{pos}}{Position on the chromosome (numeric)}
#'     \item{\code{ref}}{Referent nucleotid (\code{A}, \code{C}, \code{G} or \code{T})}
#'     \item{\code{alt}}{Alteration nucleotid (\code{A}, \code{C}, \code{G} or \code{T})}
#'     \item{\code{uniprot}}{Uniprot protein identifier (factor)}
#'   }
#' @docType data
#' @keywords data
NULL

#' Toy example of GRanges object
#'
#' @name example_GRanges
#' @format A \code{GRanges} object with 11 rows and several columns:
#'   \describe{
#'     \item{\code{seqnames}}{Chromosome number (only \code{Y} in this example)}
#'     \item{\code{ranges}}{\code{IRanges} object for which \code{start}=\code{end}: position on the chromosome}
#'     \item{\code{reference}}{Referent nucleotid (\code{A}, \code{C}, \code{G} or \code{T})}
#'     \item{\code{alteration}}{Alteration nucleotid (\code{A}, \code{C}, \code{G} or \code{T})}
#'   }
#' @docType data
#' @keywords data
NULL

#' Assign functional prediction rfPred scores to human missense variants
#'
#' rfPred is a statistical method which combines 5 algorithms predictions in a
#' random forest model: SIFT, Polyphen2, LRT, PhyloP and MutationTaster. These scores
#' are available in the dbNFSP database for all the possible missense variants in hg19
#' version, and the package rfPred gives a composite score more reliable than each of
#' the isolated algorithms.
#'
#' @param variant_list A variants list in a \code{data.frame} containing 4 or 5 columns:
#' chromosome number, hg19 genomic position on the chromosome, reference nucleotid, variant nucleotid and uniprot protein identifier (optional);
#' or a character string of the path to a VCF (Variant Call Format) file; or a \code{GRanges} object with metadata containing textually \code{reference}, 
#' \code{alteration} and \code{proteine} (optional) columns names
#' for reference and alteration
#' @param data Path to the compressed TabixFile, either on the server (default) or on the user's computer
#' @param index Path to the index of the TabixFile, either on the server (default) or on the user's computer
#' @param all.col \code{TRUE} to return all available information, \code{FALSE} to return a more compact result (the most informative columns, see Value)
#' @param file.export Optional, name of the CSV file in which export the results (default is \code{NULL})
#' @param n.cores number of cores to use when scaning the TabixFile, can be efficient for large request (default is 1)
#' @return The variants list with the assigned rfPred scores, as well as the scores used to build rfPred meta-score: SIFT, phyloP, MutationTaster, LRT (transformed) and Polyphen2 (corresponding to Polyphen2_HVAR_score). The data frame returned contains these columns:
#'   \item{chromosome}{chromosome number}
#'   \item{position_hg19}{physical position on the chromosome as to hg19 (1-based coordinate)}
#'   \item{reference}{reference nucleotide allele (as on the + strand)}
#'   \item{alteration}{alternative nucleotide allele (as on the + strand)}
#'   \item{proteine}{Uniprot accession number}
#'   \item{aaref}{reference amino acid}
#'   \item{aaalt}{alternative amino acid}
#'   \item{aapos}{amino acid position as to the protein}
#'   \item{rfPred_score}{rfPred score betwen 0 and 1 (higher it is, higher is the probability of pathogenicity)}
#'   \item{SIFT_score}{SIFT score between 0 and 1 (higher it is, higher is the probability of pathogenicity contrary to the original SIFT score) = 1-original SIFT score}
#'   \item{Polyphen2_score}{Polyphen2 (HVAR one) score between 0 and 1, used to calculate rfPred (higher it is, higher is the probability of pathogenicity)}
#'   \item{MutationTaster_score}{MutationTaster score between 0 and 1 (higher it is, higher is the probability of pathogenicity)}
#'   \item{PhyloP_score}{PhyloP score between 0 and 1 (higher it is, higher is the probability of pathogenicity): PhyloP_score=1-0.5x10^phyloP if phyloP>0 or PhyloP_score=0.5x10^-phyloP if phyloP<0}
#'  \item{LRT_score}{LRT score between 0 and 1 (higher it is, higher is the probability of pathogenicity): LRT_score=1-LRToriginalx0.5 if LRT_Omega<1 or LRT_score=LRToriginalx0.5 if LRT_Omega>=1}
#' The following columns are also returned if \code{all.col} is \code{TRUE}:
#'   \item{Uniprot_id}{Uniprot ID number}
#'   \item{genename}{gene name}
#'   \item{position_hg18}{physical position on the chromosome as to hg18 (1-based coordinate)}
#'   \item{Polyphen2_HDIV_score}{Polyphen2 score based on HumDiv, i.e. hdiv_prob. The score ranges from 0 to 1: the corresponding prediction is "probably damaging" if it is in [0.957,1]; "possibly damaging" if it is in [0.453,0.956]; "benign" if it is in [0,0.452]. Score cut-off for binary classification is 0.5, i.e. the prediction is "neutral" if the score is lower than 0.5 and "deleterious" if the score is higher than 0.5. Multiple entries separated by ";"}
#'   \item{Polyphen2_HDIV_pred}{Polyphen2 prediction based on HumDiv: \code{D} (probably damaging), \code{P} (possibly damaging) and \code{B} (benign). Multiple entries separated by ";"}
#'   \item{Polyphen2_HVAR_score}{Polyphen2 score based on HumVar, i.e. hvar_prob. The score ranges from 0 to 1, and the corresponding prediction is "probably damaging" if it is in [0.909,1]; "possibly damaging" if it is in [0.447,0.908]; "benign" if it is in [0,0.446]. Score cut-off for binary classification is 0.5, i.e. the prediction is "neutral" if the score is lower than 0.5 and "deleterious" if the score is higher than 0.5. Multiple entries separated by ";"}
#'   \item{Polyphen2_HVAR_pred}{Polyphen2 prediction based on HumVar: \code{D} (probably damaging), \code{P} (possibly damaging) and \code{B} (benign). Multiple entries separated by ";"}
#'   \item{MutationTaster_pred}{MutationTaster prediction: \code{A} (disease_causing_automatic), \code{D} (disease_causing), \code{N} (polymorphism) or \code{P} (polymorphism_automatic)}
#'   \item{phyloP}{original phyloP score}
#'   \item{LRT_Omega}{estimated nonsynonymous-to-synonymous-rate ratio}
#'   \item{LRT_pred}{LRT prediction, \code{D}(eleterious), \code{N}(eutral) or \code{U}(nknown)}
#' @author Fabienne Jabot-Hanin, Hugo Varet and Jean-Philippe Jais
#' @references Jabot-Hanin F, Varet H, Tores F and Jais J-P. 2013. rfPred: a new meta-score for functional prediction of missense variants in human exome (submitted).
#' 
#' @export
#' @docType methods
#' @rdname rfPred_scores-methods
#'
#' @examples
#' # from a data.frame without uniprot protein identifier
#' data(variant_list_Y)
#' res=rfPred_scores(variant_list = variant_list_Y[,1:4],
#'                   data = system.file("extdata", "chrY_rfPred.txtz", package="rfPred",mustWork=TRUE),
#'                   index = system.file("extdata", "chrY_rfPred.txtz.tbi", package="rfPred",mustWork=TRUE))
#' # from a data.frame with uniprot protein identifier
#' res2=rfPred_scores(variant_list = variant_list_Y,
#'                    data = system.file("extdata", "chrY_rfPred.txtz", package="rfPred",mustWork=TRUE),
#'                    index = system.file("extdata", "chrY_rfPred.txtz.tbi", package="rfPred",mustWork=TRUE))
#' # from a VCF file
#' res3=rfPred_scores(variant_list = system.file("extdata", "example.vcf", package="rfPred",mustWork=TRUE),
#'                    data = system.file("extdata", "chrY_rfPred.txtz", package="rfPred",mustWork=TRUE),
#'                    index = system.file("extdata", "chrY_rfPred.txtz.tbi", package="rfPred",mustWork=TRUE))
#' # from a GRanges object
#' data(example_GRanges)
#' res4=rfPred_scores(variant_list = example_GRanges,
#'                    data = system.file("extdata", "chrY_rfPred.txtz", package="rfPred",mustWork=TRUE),
#'                    index = system.file("extdata", "chrY_rfPred.txtz.tbi", package="rfPred",mustWork=TRUE))
#' 

setGeneric(
 name = "rfPred_scores",
 def = function(variant_list,
                data=system.file("extdata/chrY_rfPred.txtz", package="rfPred"),
                index=system.file("extdata/chrY_rfPred.txtz.tbi", package="rfPred"),
                all.col=FALSE,
                file.export=NULL,
                n.cores=1){
   standardGeneric("rfPred_scores")
 }
)

#' @rdname rfPred_scores-methods
#' @aliases rfPred_scores,data.frame-method
#' @usage rfPred_scores(variant_list,
#'                      data=system.file("extdata/chrY_rfPred.txtz", package="rfPred"),
#'                      index=system.file("extdata/chrY_rfPred.txtz.tbi", package="rfPred"),
#'                      all.col=FALSE, file.export=NULL, n.cores=1)
setMethod(
  f = "rfPred_scores",
  signature = c("data.frame"),
  definition = function(variant_list, data, index, all.col, file.export, n.cores){
    rfPred_scores_motor(variant_list, data, index, all.col, file.export, n.cores)
  }
)

#' @rdname rfPred_scores-methods
#' @aliases rfPred_scores,character-method
setMethod(
  f = "rfPred_scores",
  signature = c("character"),
  definition = function(variant_list, data, index, all.col, file.export, n.cores){
    d <- read.table(variant_list, stringsAsFactors=FALSE)
    d <- d[, c(1,2,4,5)]
    d[,1] <- sub("chr", "", d[,1])
    d[,2] <- sub(" ", "", d[,2])
    rfPred_scores_motor(d, data, index, all.col, file.export, n.cores)
  }
)

#' @rdname rfPred_scores-methods
#' @aliases rfPred_scores,GRanges-method
setMethod(
  f = "rfPred_scores",
  signature = c("GRanges"),
  definition = function(variant_list, data, index, all.col, file.export, n.cores){
    seqlevels(variant_list) <- sub("chr", "", seqlevels(variant_list))
    d <- as.data.frame(variant_list, stringsAsFactors=FALSE)
    d <- d[, c("seqnames", "start", "reference", "alteration", if(any(names(d)=="proteine")){"proteine"}else{NULL})]
    rfPred_scores_motor(d, data, index, all.col, file.export, n.cores)
  }
)

#' The package provides a function which returns the rfPred score for a list of 
#' non-synonymous missense variants. All the rfPred scores are pre-calculated and 
#' stored in a \code{TabixFile} available on a server and which can be downloaded 
#' for using the package while not connected on the Internet. The package does not 
#' work without an access to the \code{TabixFile}. However, a toy example on the 
#' chromosome Y is available within the package to test the \code{rfPred_scores} function.
#' curves with numbers of subjects at risk, compare data sets, display spaghetti-plot, build multi-contingency tables...
#' @title Assign functional prediction rfPred scores to human missense variants 
#' (random forest method based on SIFT, Polyphen2, PhyloP, LRT and Mutation Taster)
#' @author Fabienne Jabot-Hanin, Hugo Varet and Jean-Philippe Jais
#' @docType package
#' @references 
#' dbNSFP database: Liu X, Jian X and Boerwinkle E. 2011. dbNSFP: a lightweight database of human non-synonymous SNPs and their functional predictions. Human Mutation. 32:894-899.
#'
#' rfPred method: Jabot-Hanin F, Varet H, Tores F and Jais J-P. 2013. rfPred: a new meta-score for functional prediction of missense variants in human exome (submitted).
#' @name rfPred-package
NULL

\documentclass{article}

%\VignetteIndexEntry{CalculatingrfPredscoreswithpackagerfPred}

<<style, eval=TRUE, echo=FALSE, results=tex>>=
BiocStyle::latex()
@

\title{Calculating rfPred scores with package rfPred}
\author{Hugo Varet, Fabienne Jabot-Hanin and Jean-Philippe Jais}

\begin{document}
\maketitle
\newcommand{\up}[1]{\textsuperscript{#1}}
\DefineVerbatimEnvironment{Sinput}{Verbatim}{formatcom = {\color[rgb]{0, 0, 0.56}}}
\DefineVerbatimEnvironment{Soutput}{Verbatim}{formatcom = {\color[rgb]{0.56, 0, 0}}}

\section{Background}

Exome sequencing is becoming a standard tool for gene mapping of monogenic diseases. Given the vast amount of data generated by Next Generation Sequencing techniques, identification of disease causal variants is like finding a needle in a haystack. The impact assessment and the prioritization of potential pathogenic variants are expected to reduce work in biological validation, which is long and costly. \\

One of the possible approaches to determine the most probable deleterious variants in individual exomes is to use protein function alteration prediction algorithms. This package proposes a new method \cite{rfPred} based on five previously described algorithms (SIFT \cite{SIFT}, Polyphen2 \cite{Polyphen2}, LRT \cite{LRT}, PhyloP \cite{PhyloP} and MutationTaster \cite{MutationTaster}) compiled in the dbNSFP database \cite{dbNSFP}. A functional meta-score is derived from a random forest method trained on a dataset of 61,500 non-synonymous SNPs. On Two independent validation datasets, the random forest method appears to be globally better than each of the algorithms separately or in combination in a logistic regression model. rfPred scores have been pre-calculated and made available for all the possible non-synonymous SNPs of human exome.
	

\section{Computing rfPred scores}
After having launched the \R{} software, the user must load the \Rpackage{rfPred} package with:
<<>>=
library(rfPred)
@ 
Several packages whose \Rpackage{rfPred} is depending on will also be loaded (especially \Biocpkg{Rsamtools}). The package contains one main function - \Rfunction{rfPred\_scores()} - which returns the rfPred scores. It works as follows: the user gives as input a list of variants for which he/she wants the corresponding scores and the function looks for these variants in a data base which stores the pre-calculated scores. It avoids re-calculating the scores for each request. The list of variants can ben either a \Rclass{data.frame}, or the path to a VCF (Variant Call Format) file as a \Rclass{character} string or a \Rclass{GRanges} object (see package \Biocpkg{GenomicRanges} on \Bioconductor{} \cite{GR}). For example, the list of variants can be the data frame \Robject{variant\_list\_Y}:
<<>>=
data(variant_list_Y)
print(variant_list_Y)
@ 
\Robject{variant\_list\_Y} is a \Rclass{data.frame} which contains four or five columns respecting this order: the chromosome, the HG19 position on the chromosome, the reference nucleotid allele, the alteration nucleotid allele and optionally the protein (Uniprot accession number). Here, this \Rclass{data.frame} is part of the package, but it is possible to import data from an Excel or CSV file in \R{} (see \R{} documentation). The user can then run the function:
<<>>=
result=rfPred_scores(variant_list=variant_list_Y,
                     data=system.file("extdata/chrY_rfPred.txtz", package="rfPred"), 
                     index=system.file("extdata/chrY_rfPred.txtz.tbi", package="rfPred"))
print(result)
@ 
The argument \Robject{data} is the path to the data base (TabixFile) and the argument \Robject{index} is the path to the TabixFile index. Note that the default paths correspond to the example chromosome Y but the user can download the entire data base at \url{https://doi.org/10.5281/zenodo.7127736} (see section \ref{database} for details). \\

It is also possible to look for variants without specifying the protein. In this case, the user gives only the columns 1-4 as input: 
<<>>=
result2=rfPred_scores(variant_list=variant_list_Y[,1:4],
                      data=system.file("extdata/chrY_rfPred.txtz", package="rfPred"),
                      index=system.file("extdata/chrY_rfPred.txtz.tbi", package="rfPred"))
print(result2)
@ 
The object \Robject{result2} contains more lines (13) than the object \Robject{result} (5) because the user does not impose any matching on the protein.\\

\section{TabixFile and TabixFile index}
\label{database}
To use the entire TabixFile/index containing all the chromosomes, the user must download the two files (about 3.3 Go) in order to use them locally on his/her computer. They are available on Zenodo at \url{https://doi.org/10.5281/zenodo.7127736}. In this case, the arguments \Robject{data} and \Robject{index} must be the paths to the TabixFile and index on the user's computer.

\section{Exporting the results}
In order to share the results with non-\R{} users, the \Rfunction{rfPred\_scores()} function allows one to export the results in a CSV file thanks to the \Robject{file.export} argument:
<<>>=
result3=rfPred_scores(variant_list=variant_list_Y,
                      data=system.file("extdata/chrY_rfPred.txtz", package="rfPred"), 
                      index=system.file("extdata/chrY_rfPred.txtz.tbi", package="rfPred"),
                      file.export="results.csv")
@ 
The CSV file "results.csv" will be created in the current working directory of the \R{} session.

\section{Number of cores}
Computers with multi-core processors are able to run several tasks simultaneously. The \Robject{n.cores} argument of the \Rfunction{rfPred\_scores()} function exploits this possibility. Specifying \Robject{n.cores=4} instead of \Robject{n.cores=1} divides the computational time by about 2.5. For example, the function ran during 106 second on a 121,606 rows variants list using a 3.3 GHz Intel\textregistered Core\texttrademark i5 computer. However, for small requests, one should use only one core to avoid the overhead time due to opening hidden \R{} sessions and lauching the dependent packages.

\section{rfPred random forest model}
One may want to compute the rfPred score from his/her own SIFT, Polyphen2, LRT, PhyloP and MutationTaster scores. This functionnality does not appear within the package but we have made the model available on our website (\url{http://www.sbim.fr/rfPred/}) in a .RData file (about 52 Mo). The \R{} object \Robject{rfPred\_model} has to be given as input of the \Rfunction{predict} function of the \CRANpkg{randomForest} package in addition of the 5 scores. The scores used to build the random forest are \cite{dbNSFPweb}:

\begin{itemize}
\item SIFT\_score = $1-$original SIFT score;
\item Polyphen2\_score = original HVAR Polyphen2 score;
\item MutationTaster\_score = original MutationTaster score;
\item PhyloP\_score = $1 - 0.5 \times 10$\up{phyloP} if phyloP $\geq 0$ or $0.5 \times 10$\up{-phyloP} if phyloP $<0$;
\item LRT\_score = $1 - 0.5\ \times$ LRToriginal if LRT\_Omega $<1$ or $0.5\ \times$ LRToriginal if LRT\_Omega $\geq 1$.
\end{itemize}


Note that all these scores have to be stored in a \Rclass{data.frame} whose column names are textually \Robject{SIFT\_score}, \Robject{PhyloP\_score}, \Robject{Polyphen2\_score}, \Robject{LRT\_score} and \Robject{MutationTaster\_score} in order to match with the model parameters.

\begin{thebibliography}{9}
   \bibitem{rfPred}
          Jabot-Hanin F and Varet H and Tores F and Jais JP,
          \emph{rfPred: a new meta-score for functional prediction of missense variants in human exome}.
          (submitted) 2013.
   \bibitem{SIFT}
          Kumar P and Henikoff S and Ng PC,  
          \emph{Predicting the effects of coding non-synonymous variants on protein function using the SIFT algorithm}.
          Nat Protoc 2009, VOL.4 NO.8.
   \bibitem{Polyphen2}
          Adzhubei IA and Schmidt S and Peshkin L et al,
		  \emph{A method and server for predicting damaging missense mutations}.
		  Nat Methods 2010 7(4):248-249.
   \bibitem{LRT}
          Muse SV and Gaut BS,
          \emph{A Likelihood Approach for Comparing Synonymous and Nonsynonymous Nucleotide Substitution Rates, with Application to the Chloroplast Genome}.
          Mol Biol Evol 1994 1(5):175-724.
   \bibitem{PhyloP}
          Margulies EH and Cooper GM and Asimenos G et al,
		  \emph{Analyses of deep mammalian sequence alignments and constraint predictions for 1\% of the human genome}.
          Genome Res 2007 17:760-774
   \bibitem{MutationTaster}
          Schwarz JM and Rodelsperger and Schuelke M and Seelow D,
		  \emph{MutationTaster evaluates diseasecausing potential of sequence alterations}.
          Nat Methods 2010 7(8)
   \bibitem{dbNSFP}
          Liu X and Jian X and and Boerwinkle E, 
          \emph{dbNSFP: a lightweight database of human non-synonymous SNPs and their functional predictions}.
          Hum Mutat 2011 32:894-899.
   \bibitem{GR}
          Aboyoun P and Pages H and Lawrence M,
          \emph{GenomicRanges: Representation and manipulation of genomic intervals}.
          R package version 1.12.4.
   \bibitem{dbNSFPweb}
          dbNSFP v1.3 READ-ME, \url{http://dbnsfp.houstonbioinformatics.org/dbNSFPzip/dbNSFPv1.3.readme.txt}.
		  
\end{thebibliography}

\end{document}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rfPred-package.r
\docType{package}
\name{rfPred-package}
\alias{rfPred}
\alias{rfPred-package}
\title{Assign functional prediction rfPred scores to human missense variants 
(random forest method based on SIFT, Polyphen2, PhyloP, LRT and Mutation Taster)}
\description{
The package provides a function which returns the rfPred score for a list of 
non-synonymous missense variants. All the rfPred scores are pre-calculated and 
stored in a \code{TabixFile} available on a server and which can be downloaded 
for using the package while not connected on the Internet. The package does not 
work without an access to the \code{TabixFile}. However, a toy example on the 
chromosome Y is available within the package to test the \code{rfPred_scores} function.
curves with numbers of subjects at risk, compare data sets, display spaghetti-plot, build multi-contingency tables...
}
\references{
dbNSFP database: Liu X, Jian X and Boerwinkle E. 2011. dbNSFP: a lightweight database of human non-synonymous SNPs and their functional predictions. Human Mutation. 32:894-899.

rfPred method: Jabot-Hanin F, Varet H, Tores F and Jais J-P. 2013. rfPred: a new meta-score for functional prediction of missense variants in human exome (submitted).
}
\author{
Fabienne Jabot-Hanin, Hugo Varet and Jean-Philippe Jais
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rfPred_scores_motor.r
\name{rfPred_scores_motor}
\alias{rfPred_scores_motor}
\title{Motor of \code{rfPred_scores}}
\usage{
rfPred_scores_motor(variant_list, data, index, all.col, file.export, n.cores)
}
\arguments{
\item{variant_list}{Variants list in a \code{data.frame} containing 4 or 5 columns:
chromosome number, hg19 genomic position on the chromosome, reference nucleotid, variant nucleotid and uniprot protein identifier (optional)}

\item{data}{Path to the compressed TabixFile, either on the server (default) or on the user's computer}

\item{index}{Path to the index of the TabixFile, either on the server (default) or on the user's computer}

\item{all.col}{\code{TRUE} to return all available information, \code{FALSE} to return a more compact result (the most informative columns, see Value)}

\item{file.export}{Optional, name of the CSV file in which export the results (default is \code{NULL})}

\item{n.cores}{number of cores to use when scaning the TabixFile, can be efficient for large request (default is 1)}
}
\value{
see the \code{\link{rfPred_scores}} function
}
\description{
Motor of \code{rfPred_scores}
}
\note{
This function is called by the \code{rfPred_scores} S4 method
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/example_GRanges.r
\docType{data}
\name{example_GRanges}
\alias{example_GRanges}
\title{Toy example of GRanges object}
\format{
A \code{GRanges} object with 11 rows and several columns:
  \describe{
    \item{\code{seqnames}}{Chromosome number (only \code{Y} in this example)}
    \item{\code{ranges}}{\code{IRanges} object for which \code{start}=\code{end}: position on the chromosome}
    \item{\code{reference}}{Referent nucleotid (\code{A}, \code{C}, \code{G} or \code{T})}
    \item{\code{alteration}}{Alteration nucleotid (\code{A}, \code{C}, \code{G} or \code{T})}
  }
}
\description{
Toy example of GRanges object
}
\keyword{data}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/variant_list_Y.r
\docType{data}
\name{variant_list_Y}
\alias{variant_list_Y}
\title{Toy example of data.frame}
\format{
A data frame with 5 observations on the following 5 variables:
  \describe{
    \item{\code{chr}}{Chromosome number (only \code{Y} in this example)}
    \item{\code{pos}}{Position on the chromosome (numeric)}
    \item{\code{ref}}{Referent nucleotid (\code{A}, \code{C}, \code{G} or \code{T})}
    \item{\code{alt}}{Alteration nucleotid (\code{A}, \code{C}, \code{G} or \code{T})}
    \item{\code{uniprot}}{Uniprot protein identifier (factor)}
  }
}
\description{
Toy example of data.frame
}
\keyword{data}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rfPred_scores-methods.r
\docType{methods}
\name{rfPred_scores}
\alias{rfPred_scores}
\alias{rfPred_scores,data.frame-method}
\alias{rfPred_scores,character-method}
\alias{rfPred_scores,GRanges-method}
\title{Assign functional prediction rfPred scores to human missense variants}
\usage{
rfPred_scores(
  variant_list,
  data = system.file("extdata/chrY_rfPred.txtz", package = "rfPred"),
  index = system.file("extdata/chrY_rfPred.txtz.tbi", package = "rfPred"),
  all.col = FALSE,
  file.export = NULL,
  n.cores = 1
)

rfPred_scores(variant_list,
                     data=system.file("extdata/chrY_rfPred.txtz", package="rfPred"),
                     index=system.file("extdata/chrY_rfPred.txtz.tbi", package="rfPred"),
                     all.col=FALSE, file.export=NULL, n.cores=1)

\S4method{rfPred_scores}{character}(
  variant_list,
  data = system.file("extdata/chrY_rfPred.txtz", package = "rfPred"),
  index = system.file("extdata/chrY_rfPred.txtz.tbi", package = "rfPred"),
  all.col = FALSE,
  file.export = NULL,
  n.cores = 1
)

\S4method{rfPred_scores}{GRanges}(
  variant_list,
  data = system.file("extdata/chrY_rfPred.txtz", package = "rfPred"),
  index = system.file("extdata/chrY_rfPred.txtz.tbi", package = "rfPred"),
  all.col = FALSE,
  file.export = NULL,
  n.cores = 1
)
}
\arguments{
\item{variant_list}{A variants list in a \code{data.frame} containing 4 or 5 columns:
chromosome number, hg19 genomic position on the chromosome, reference nucleotid, variant nucleotid and uniprot protein identifier (optional);
or a character string of the path to a VCF (Variant Call Format) file; or a \code{GRanges} object with metadata containing textually \code{reference}, 
\code{alteration} and \code{proteine} (optional) columns names
for reference and alteration}

\item{data}{Path to the compressed TabixFile, either on the server (default) or on the user's computer}

\item{index}{Path to the index of the TabixFile, either on the server (default) or on the user's computer}

\item{all.col}{\code{TRUE} to return all available information, \code{FALSE} to return a more compact result (the most informative columns, see Value)}

\item{file.export}{Optional, name of the CSV file in which export the results (default is \code{NULL})}

\item{n.cores}{number of cores to use when scaning the TabixFile, can be efficient for large request (default is 1)}
}
\value{
The variants list with the assigned rfPred scores, as well as the scores used to build rfPred meta-score: SIFT, phyloP, MutationTaster, LRT (transformed) and Polyphen2 (corresponding to Polyphen2_HVAR_score). The data frame returned contains these columns:
  \item{chromosome}{chromosome number}
  \item{position_hg19}{physical position on the chromosome as to hg19 (1-based coordinate)}
  \item{reference}{reference nucleotide allele (as on the + strand)}
  \item{alteration}{alternative nucleotide allele (as on the + strand)}
  \item{proteine}{Uniprot accession number}
  \item{aaref}{reference amino acid}
  \item{aaalt}{alternative amino acid}
  \item{aapos}{amino acid position as to the protein}
  \item{rfPred_score}{rfPred score betwen 0 and 1 (higher it is, higher is the probability of pathogenicity)}
  \item{SIFT_score}{SIFT score between 0 and 1 (higher it is, higher is the probability of pathogenicity contrary to the original SIFT score) = 1-original SIFT score}
  \item{Polyphen2_score}{Polyphen2 (HVAR one) score between 0 and 1, used to calculate rfPred (higher it is, higher is the probability of pathogenicity)}
  \item{MutationTaster_score}{MutationTaster score between 0 and 1 (higher it is, higher is the probability of pathogenicity)}
  \item{PhyloP_score}{PhyloP score between 0 and 1 (higher it is, higher is the probability of pathogenicity): PhyloP_score=1-0.5x10^phyloP if phyloP>0 or PhyloP_score=0.5x10^-phyloP if phyloP<0}
 \item{LRT_score}{LRT score between 0 and 1 (higher it is, higher is the probability of pathogenicity): LRT_score=1-LRToriginalx0.5 if LRT_Omega<1 or LRT_score=LRToriginalx0.5 if LRT_Omega>=1}
The following columns are also returned if \code{all.col} is \code{TRUE}:
  \item{Uniprot_id}{Uniprot ID number}
  \item{genename}{gene name}
  \item{position_hg18}{physical position on the chromosome as to hg18 (1-based coordinate)}
  \item{Polyphen2_HDIV_score}{Polyphen2 score based on HumDiv, i.e. hdiv_prob. The score ranges from 0 to 1: the corresponding prediction is "probably damaging" if it is in [0.957,1]; "possibly damaging" if it is in [0.453,0.956]; "benign" if it is in [0,0.452]. Score cut-off for binary classification is 0.5, i.e. the prediction is "neutral" if the score is lower than 0.5 and "deleterious" if the score is higher than 0.5. Multiple entries separated by ";"}
  \item{Polyphen2_HDIV_pred}{Polyphen2 prediction based on HumDiv: \code{D} (probably damaging), \code{P} (possibly damaging) and \code{B} (benign). Multiple entries separated by ";"}
  \item{Polyphen2_HVAR_score}{Polyphen2 score based on HumVar, i.e. hvar_prob. The score ranges from 0 to 1, and the corresponding prediction is "probably damaging" if it is in [0.909,1]; "possibly damaging" if it is in [0.447,0.908]; "benign" if it is in [0,0.446]. Score cut-off for binary classification is 0.5, i.e. the prediction is "neutral" if the score is lower than 0.5 and "deleterious" if the score is higher than 0.5. Multiple entries separated by ";"}
  \item{Polyphen2_HVAR_pred}{Polyphen2 prediction based on HumVar: \code{D} (probably damaging), \code{P} (possibly damaging) and \code{B} (benign). Multiple entries separated by ";"}
  \item{MutationTaster_pred}{MutationTaster prediction: \code{A} (disease_causing_automatic), \code{D} (disease_causing), \code{N} (polymorphism) or \code{P} (polymorphism_automatic)}
  \item{phyloP}{original phyloP score}
  \item{LRT_Omega}{estimated nonsynonymous-to-synonymous-rate ratio}
  \item{LRT_pred}{LRT prediction, \code{D}(eleterious), \code{N}(eutral) or \code{U}(nknown)}
}
\description{
rfPred is a statistical method which combines 5 algorithms predictions in a
random forest model: SIFT, Polyphen2, LRT, PhyloP and MutationTaster. These scores
are available in the dbNFSP database for all the possible missense variants in hg19
version, and the package rfPred gives a composite score more reliable than each of
the isolated algorithms.
}
\examples{
# from a data.frame without uniprot protein identifier
data(variant_list_Y)
res=rfPred_scores(variant_list = variant_list_Y[,1:4],
                  data = system.file("extdata", "chrY_rfPred.txtz", package="rfPred",mustWork=TRUE),
                  index = system.file("extdata", "chrY_rfPred.txtz.tbi", package="rfPred",mustWork=TRUE))
# from a data.frame with uniprot protein identifier
res2=rfPred_scores(variant_list = variant_list_Y,
                   data = system.file("extdata", "chrY_rfPred.txtz", package="rfPred",mustWork=TRUE),
                   index = system.file("extdata", "chrY_rfPred.txtz.tbi", package="rfPred",mustWork=TRUE))
# from a VCF file
res3=rfPred_scores(variant_list = system.file("extdata", "example.vcf", package="rfPred",mustWork=TRUE),
                   data = system.file("extdata", "chrY_rfPred.txtz", package="rfPred",mustWork=TRUE),
                   index = system.file("extdata", "chrY_rfPred.txtz.tbi", package="rfPred",mustWork=TRUE))
# from a GRanges object
data(example_GRanges)
res4=rfPred_scores(variant_list = example_GRanges,
                   data = system.file("extdata", "chrY_rfPred.txtz", package="rfPred",mustWork=TRUE),
                   index = system.file("extdata", "chrY_rfPred.txtz.tbi", package="rfPred",mustWork=TRUE))

}
\references{
Jabot-Hanin F, Varet H, Tores F and Jais J-P. 2013. rfPred: a new meta-score for functional prediction of missense variants in human exome (submitted).
}
\author{
Fabienne Jabot-Hanin, Hugo Varet and Jean-Philippe Jais
}
